Logix32

Logix32

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

This driver is used for connecting to one ore more Logix PLCs via a network connection.


LOGIX32 - Data sheet

Logix32 -> LOGIX32 - Data sheet

General: |
Driver file name | LOGIX32.exe
Driver description | Allen-Bradley Logix Ethernet
PLC types | ControlLogix 5550 and 5555 PLCs are supported; Compact Logix Ethernet PLC L35E are supported;MicroLogix PLCs are not supported.
PLC manufacturer | Allen-Bradley; Rockwell;

Driver supports: |
Protocol | EtherNet/IP;
Addressing: address based | -
Addressing: name based | x
Spontaneous communication | -
Polling communication | x
Online browsing | x
Offline browsing | x
Real-time capable | -
Blockwrite | x
Modem capable | -
Serial logging | -
RDA numerical | -
RDA String | -

Prerequisites: |
Hardware PC | Standard network card
Software PC | -
Hardware PLC | ControlLogix needs AB 1756 ENET interface card
Software PLC | -
Requires v-dll | -

Platforms: |
Operating systems | Windows CE 5.0, CE 6.0; Windows XP, Vista, 7, Server 2003, Server 2008/R2;
CE platforms | x86; ARM; Pocket-PC;


Driver history

Logix32 -> Driver history

Date | Driver version | Change
07.07.08 | 3400 | Re-created driver documentation
22.10.08 | 4100 | added private and alias variables


Requirements

Logix32 -> Requirements

This chapter contains information on the requirements that are necessary for use of this driver.


PC

Logix32 -> Requirements -> PC

This driver supports a connection via the standard network card of the PC. Make sure that the PLC and the PC are in the same network range and that the subnet masks are set accordingly on both devices.


PLC

Logix32 -> Requirements -> PLC

PLC can be configured with tools (AllanBradley).


Configuration

Logix32 -> Configuration

In this chapter you will learn how to use the driver in a project and which settings you can change.

info Info

Find out more about further settings for zenon variables in the chapter Variables of the online manual.


Creating a driver

Logix32 -> Configuration -> Creating a driver

In order to create a new driver:

  • Right-click on Driver in the Project Manage and select Driver new in the context menu.
  • In the following dialog the control system offers a list of all available drivers.

  • Select the desired driver and give it a name:
    • The driver name has to be unique, i.e. if one and the same driver is to be used several times in one project, every time a new name has to be given each time.
    • The driver name is part of the file name. Therefore it may only contain characters which are supported by the operating system. Invalid characters are replaced by an underscore (_).
    • Attention: This name cannot be changed later on.
  • Confirm the dialog with OK. In the following dialog the single configurations of the drivers are defined.
  • Only the respective required drivers need to be loaded for a project. Later loading of an additional driver is possible without problems.

info Info

For new projects and for existing projects which are converted to version 6.21 or higher, the following drivers are created automatically:

  • Internal
  • MathDr32
  • SysDrv.


Settings in the driver dialog

Logix32 -> Configuration -> Settings in the driver dialog

You can change the following settings of the driver:


General

Logix32 -> Configuration -> Settings in the driver dialog -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Parameters

Description

Mode

Allows to switch between hardware mode and simulation mode

  • Hardware:

    A connection to the control is established.

  • Simulation static

    No communication between to the control is established, the values are simulated by the driver. In this modus the values remain constant or the variables keep the values which were set by zenon Logic. Each variable has its own memory area, e.g. two variables of the type marker with offset 79 can have different values in the Runtime and do not influence each other. Exception: The simulator driver.

  • Simulation - counting

    No communication between to the control is established, the values are simulated by the driver. In this modus the driver increments the values within a value range automatically.

  • Simulation - programmed

    N communication is established to the PLC. The values are calculated by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in a zenon Logic Runtime which is integrated in the driver. For details see chapter Driver simulation.

Keep update list in the memory

Variables which were requested once are still requested from the control even if they are currently not needed.
This has the advantage that e.g. multiple screen switches after the screen was opened for the first time are executed faster because the variables need not be requested again. The disadvantage is a higher load for the communication to the control.

Output can be written

Active: Outputs can be written.

Inactive: Writing of outputs is prevented.

Note: Not available for every driver.

Variable image remanent

This option saves and restores the current value, time stamp and the states of a data point.

Fundamental requirement: The variable must have a valid value and time stamp.

The variable image is saved in mode hardware if:

  • one of the states S_MERKER_1(0) up to S_MERKER8(7), REVISION(9), AUS(20) or ERSATZWERT(27) is active

The variable image is always saved if:

  • the variable is of the object type Driver variable
  • the driver runs in simulation mode. (not programmed simulation)

The following states are not restored at the start of the Runtime:

  • SELECT(8)
  • WR-ACK(40)
  • WR-SUC(41)

The mode Simulation - programmed at the driver start is not a criterion in order to restore the remanent variable image.

Stop at the Standby Server

Setting for redundancy at drivers which allow only on communication connection. For this the driver is stopped at the Standby Server and only started at the upgrade.

Attention: If this option is active, the gapless archiving is no longer guaranteed.

Active: Sets the driver at the not-process-leading Server automatically in a stop-like state. In contrast to stopping via driver command, the variable does not receive status switched off but an empty value. This prevents that at the upgrade to the Server irrelevant values are created in the AML, CEL and Historian.

Global Update time

Active: The set Global update time in ms is used for all variables in the project. The priority set at the variables is not used.
Inactive: The set priorities are used for the individual variables.

Priority

Here you set the polling times for the individual priorities. All variables with the according priority are polled in the set time. The allocation is taken place for each variable separately in the settings of the variable properties.
The communication of the individual variables are graduated in respect of importance or necessary topicality using the priorities. Thus the communication load is distributed better.

Update time for cyclical driver

The following applies for cyclical drivers:

For Set value, Advising of variables and Requests, a read cycle is immediately triggered for all drivers - regardless of the set update time. This ensures that the value is immediately available for visualization after writing. Update times can therefore be shorter than pre-set for cyclical drivers.


TCP configuration

Logix32 -> Configuration -> Settings in the driver dialog -> TCP configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Parameters | Description
TCP configuration file | The file Default.lix is set by default and has to be in the current project directory. The filename Default.lix can be changed for a project by simply overwriting it.
Error waiting time (ms) | If the connection fails, the driver will take this amount of time between re-attempts to establish communication. Shorter times result in a higher need of network resources.
Use identification for external name | The name of the variable is not resolved via the name but via the identification.


TCP/IP connection

Logix32 -> Configuration -> Settings in the driver dialog -> TCP/IP connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Parameters | Description
Connection file | Selected configuration file
Connections | Displays the connection names with the corresponding hardware addresses. By selecting the connection name with the mouse the connection parameters are displayed.
Net address | Corresponds to the net address of the variable definition.
Name | Freely definable name.
IP address | IP address, depends on the settings of the AB 1756 ENET communication processor.
Timeout | Timeout time in milliseconds for the response from the communication processor.
CPU insertion number | Number of the slot into which the CPU was inserted.
New | Create new connection
Edit | Edit existing connection Select the desired connection in the connection list, press button "Edit Conn.". Make changes and close with "Save".
Delete | Delete existing connection
Save | Save new/amended entries.
Cancel | Discard amended entries.
OK | Accept changes in the dialog and close dialog. Only available if no connection is in the "edit" state.
Cancel | Discards all changes and closes dialog.
Help | Opens online help.

info Info

Maximum number of connections: 256 (0-255).

Create new connection

  1. click on the button New
  2. Enter the connection details.
  3. Click on Save

Edit connection

  1. select the connection in the connection list
  2. click on the button Edit
  3. change the connection parameters
  4. finish with Save

Delete connection

  1. select the connection in the connection list
  2. click on the button Delete
  3. the connection will be removed from the list

Show connection details

Highlight the desired connection in the connection list.


Creating variables

Logix32 -> Creating variables

This is how you can create variables in the zenon Editor:


Creating variables in the Editor

Logix32 -> Creating variables -> Creating variables in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Variables can be created:

  • as simple variables
  • in arrays
  • as structure variables

Variable dialog

To create a new variable, regardless of which type:

  1. Select the New variable command in the Variables node in the context menu

  2. The dialog for configuring variables is opened
  3. configure the variable
  4. The settings that are possible depends on the type of variables

Property

Description

Name

Distinct name of the variable. If a variable with the same name already exists in the project, no additional variable can be created with this name.

Attention: The # character is not permitted in variable names. If non-permitted characters are used, creation of variables cannot be completed and the Finish button remains inactive.

Drivers

Select the desired driver from the drop-down list.

Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.

Driver object type

Select the appropriate driver object type from the drop-down list.

Data type

Select the desired data type. Click on the ... button to open the selection dialog.

Array settings

Expanded settings for array variables. You can find details in the Arrays chapter.

Addressing options

Expanded settings for arrays and structure variables. You can find details in the respective section.

Automatic element activation

Expanded settings for arrays and structure variables. You can find details in the respective section.

Inheritance from data type

Measuring range, Signal range and Set value are always:

  • derived from the datatype
  • Automatically adapted if the data type is changed

Note for signal range: If a change is made to a data type that does not support the set signal range, the signal range is amended automatically. For example, for a change from INT to SINT, the signal range is changed to 127. The amendment is also carried out if the signal range was not inherited from the data type. In this case, the measuring range must be adapted manually.


Addressing

Logix32 -> Creating variables -> Addressing

The driver communicates on a name basis (via the variable name) or optionally, via the identification.

Property

Description

Name

Freely definable name

Attention: the name must be unique within each control system project. The name will be used for the unique addressing.

Identification

Any text can be entered here, e.g. for resource labels, comments, etc. Optionally, the identification can be used for addressing. Please make sure that the name is not used a second time with a different data type.

Net address

Bus address or net address of the variable.

This address refers to the bus address in the connection configuration of the driver. This defines the PLC, on which the variable resides.

Data block

not used for this driver

Offset

not used for this driver

Alignment

not used for this driver

Bit number

not used for this driver

String length

Only available for String variables: Maximum number of characters that the variable can take. Must always be entered manually. The online import does not support any Strings.

Driver object type

Depending on the employed driver, an object type is selected during the creation of the variable; the type can be changed here later.

Data type

Data type of the variable, which is selected during the creation of the variable; the type can be changed here later.

ATTENTION: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

Limitations

Only global, private and alias variables are supported.

The following pre-defined data types are supported for these tags: (TIMER, COUNTER, PID, STRING, BOOL, BYTE, INT, SINT, UINT, USINT, WORD, DINT, UDINT, DWORD, REAL, LREAL)

The variable names are case sensitive.

Creating string variables via browsing (see below) is not possible; you have to manually create the zenon String variables with the same variable names or the same variable identifications that are used in the PLC.

Example: There is a String structure in the PLC that looks as follows:

  • long StringStrukt.LEN
  • char StringStrukt.DATA[60]

Please enter "StringStrukt.DATA[0]" as the name or identification.

Also, copy the array length (in this case: 60 Bytes) to the field String length.

There must be no other variable with the same name and a

different data type!

There must be no additional Byte variable with this name.

"StringStrukt.DATA[0]".

Control Logix variable types

All pre-defined and user-defined variables (tags) are supported. You can access single bits of the following basic data types via variable name/bit number.

Tag or array type | Sub element
SINT | /00 - 07 Example: MySINT/01
INT | /00 - 15 Example: MyINT/03
DINT | /00 - 31 Example: MyDINT/23

zenon array variables

A zenon array variable represents a memory area (arrays or structures) of the Control Logix.

You have read and write access to the zenon array variable via the Recipe Manager and VBA. One advantage of the Control Logix is that block reading and block writing is very efficient. Supported driver objects for array variables are (i/u8Bit ,i/u16Bit ,i/u32Bit ,float).

A zenon array variable is created via the variable dialog. Enter the size of the array in the input field "Array size". If you have the same data type as you have on the Control Logix, you also have to enter the same dimension in the input field "Array size".

Example Example

Example1 with a Control Logix array: There is a global variable UDINT arTest[106] on the Control Logix. See the illustration below for the definition on the zenon page.

You can also put a zenon array variable over a Control Logix structure. This means that an unformatted binary dump of the structure will be read and written.

A zenon array variable is created via the variable dialog. Enter the size of the structure in the input field "Array size".

If it is an „i/u8Bit" array, you have to enter the size of the structure in Bytes in the input field "Array size".

If it is an „i/u16Bit" array, you have to enter the size of the structure in Bytes/2 in the input field "Array size".

If it is an „i/u32Bit" array, you have to enter the size of the structure in Bytes/4 in the input field "Array size".

If it is a „float" array, you have to enter the size of the structure in Bytes/4 in the input field "Array size".

info Info

The number of Bytes contained in a structure or an array can be found out in the development environment (RSLogix 5000).

Example Example

Example2 with a Control Logix structure: There is a global variable STRUKT1 sStrukt1 on the Control Logix; its size is 100 Bytes. See the illustration below for the definition on the zenon page.


Driver objects and datatypes

Logix32 -> Creating variables -> Driver objects and datatypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Driver objects are areas available in the PLC, such as markers, data blocks etc. Here you can find out which driver objects are provided by the driver and which IEC data types can be assigned to the respective driver objects.


Driver objects

Logix32 -> Creating variables -> Driver objects and datatypes -> Driver objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The following object types are available in this driver:

Driver object type | Channel type | Read / Write | Supported data types | Comment
PLC marker | 35 | R / W | REAL, BOOL, DINT, UDINT, USINT, INT, UINT, SINT, STRING |
Driver variable | 35 | R / W | BOOL, SINT, USINT, INT, UINT, DINT, UDINT, REAL, STRING | Variables for the statistical analysis of communication. Find out more in the chapter about the Driver variables


Mapping of the data types

Logix32 -> Creating variables -> Driver objects and datatypes -> Mapping of the data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

All variables in zenon are derived from IEC data types. The following table compares the IEC datatypes with the datatypes of the PLC.

PLC | zenon | Data type
BOOL | BOOL | 8
SINT | USINT | 9
SINT | SINT | 10
INT | UINT | 2
INT | INT | 1
DINT | UDINT | 4
DINT | DINT | 3
- | ULINT | 27
- | LINT | 26
REAL | REAL | 5
- | LREAL | 6
SINT[82] | STRING | 12
- | WSTRING | 21
- | DATE | 18
- | TIME | 17
- | DATE_AND_TIME | 20
- | TOD (Time of Day) | 19

Data type: The property Data type is the internal numerical name of the data type. It is also used for the extended DBF import/export of the variables.


Creating variables by importing

Logix32 -> Creating variables -> Creating variables by importing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Variables can also be imported by importing them. The XML and DBF import is available for every driver.


XML import of variables from another zenon project

Logix32 -> Creating variables -> Creating variables by importing -> XML import of variables from another zenon project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

For the import/export of variables the following is true:

  • The import/export must not be started from the global project.
  • The start takes place via:
    • Context menu of variables or data typ in the project tree
    • or context menu of a variable or a data type
    • or symbol in the symbol bar variables

attention Attention

When importing/overwriting an existing data type, all variables based on the existing data type are changed.

Example:

There is a data type XYZ derived from the type INTwith variables based on this data type. The XML file to be imported also contains a data type with the name XYZ but derived from type STRING. If this data type is imported, the existing data type is overwritten and the type of all variables based on it is adjusted. I.e. the variables are now no longer INT variables, but STRING variables.


DBF Import/Export

Logix32 -> Creating variables -> Creating variables by importing -> DBF Import/Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Data can be exported to and imported from dBase.

Import DBF file

To start the import:

  1. right-click on the variable list
  2. in the drop-down menu of Extended export/import... select the Import dBase command
  3. follow the import assistant

The format of the file is described in the chapter File structure.

info Info

Note:

  • Driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.
  • dBase does not support structures or arrays (complex variables) at import.

Export DBF file

To start the export:

  1. right-click on the variable list
  2. in the drop-down menu of Extended export/import... select the Export dBase command
  3. follow the export assistant

attention Attention

DBF files:

  • must correspond to the 8.3 DOS format for filenames (8 alphanumeric characters for name, 3 character suffix, no spaces)
  • must not have dots (.) in the path name.
    e.g. the path C:\users\John.Smith\test.dbf is invalid.
    Valid: C:\users\JohnSmith\test.dbf
  • must be stored close to the root directory in order to fulfill the limit for file name length including path: maximum 255 characters

The format of the file is described in the chapter File structure.

info Info

dBase does not support structures or arrays (complex variables) at export.

File structure of the dBase export file

The dBaseIV file must have the following structure and contents for variable import and export:

attention Attention

dBase does not support structures or arrays (complex variables) when exporting.

DBF files must:

  • correspond to the 8.3 DOS format for filenames (8 alphanumeric characters for name, 3 character suffix, no spaces)
  • Be stored close to the root directory (Root)

Design

Description | Type | Field size | Comment
KANALNAME | Char | 128 | Variable name. The length can be limited using the MAX_LAENGE entry in project.ini .
KANAL_R | C | 128 | The original name of a variable that is to be replaced by the new name entered under "KANALNAME" (field/column must be entered manually). The length can be limited using the MAX_LAENGE entry in project.ini .
KANAL_D | Log | 1 | The variable is deleted with the 1 entry (field/column has to be created by hand).
TAGNR | C | 128 | Identification. The length can be limited using the MAX_LAENGE entry in project.ini .
EINHEIT | C | 11 | Technical unit
DATENART | C | 3 | Data type (e.g. bit, byte, word, ...) corresponds to the data type.
KANALTYP | C | 3 | Memory area in the PLC (e.g. marker area, data area, ...) corresponds to the driver object type.
HWKANAL | Num | 3 | Bus address
BAUSTEIN | N | 3 | Datablock address (only for variables from the data area of the PLC)
ADRESSE | N | 5 | Offset
BITADR | N | 2 | For bit variables: bit address For byte variables: 0=lower, 8=higher byte For string variables: Length of string (max. 63 characters)
ARRAYSIZE | N | 16 | Number of variables in the array for index variables ATTENTION: Only the first variable is fully available. All others are only available for VBA or the Recipe Group Manager
LES_SCHR | R | 1 | Write-Read-Authorization 0: Not allowed to set value. 1: Allowed to set value.
MIT_ZEIT | R | 1 | time stamp in zenon (only if supported by the driver)
OBJEKT | N | 2 | Driver-specific ID number of the primitive object comprises KANALTYP and DATENART
SIGMIN | Float | 16 | Non-linearized signal - minimum (signal resolution)
SIGMAX | F | 16 | Non-linearized signal - maximum (signal resolution)
ANZMIN | F | 16 | Technical value - minimum (measuring range)
ANZMAX | F | 16 | Technical value - maximum (measuring range)
ANZKOMMA | N | 1 | Number of decimal places for the display of the values (measuring range)
UPDATERATE | F | 19 | Update rate for mathematics variables (in sec, one decimal possible) not used for all other variables
MEMTIEFE | N | 7 | Only for compatibility reasons
HDRATE | F | 19 | HD update rate for historical values (in sec, one decimal possible)
HDTIEFE | N | 7 | HD entry depth for historical values (number)
NACHSORT | R | 1 | HD data as postsorted values
DRRATE | F | 19 | Updating to the output (for zenon DDE server, in [s], one decimal possible)
HYST_PLUS | F | 16 | Positive hysteresis, from measuring range
HYST_MINUS | F | 16 | Negative hysteresis, from measuring range
PRIOR | N | 16 | Priority of the variable
REAMATRIZE | C | 32 | Allocated reaction matrix
ERSATZWERT | F | 16 | Substitute value, from measuring range
SOLLMIN | F | 16 | Minimum for set value actions, from measuring range
SOLLMAX | F | 16 | Maximum for set value actions, from measuring range
VOMSTANDBY | R | 1 | Get value from standby server; the value of the variable is not requested from the server but from the standby-server in redundant networks
RESOURCE | C | 128 | Resource label. Free string for export and display in lists. The length can be limited using the MAX_LAENGE entry in project.ini .
ADJWVBA | R | 1 | Non-linear value adaption: 0: Non-linear value adaption is used 1: non linear value adaption is not used
ADJZENON | C | 128 | Linked VBA macro for reading the variable value for non-linear value adjustment.
ADJWVBA | C | 128 | Linked VBA macro for writing the variable value for non-linear value adjustment.
ZWREMA | N | 16 | Linked counter REMA.
MAXGRAD | N | 16 | Gradient overflow for counter REMA.

attention Attention.

When importing, the driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.

Limit definition

Limit definition for limit values 1 to 4, and status 1 to 4:

Description | Type | Field size | Comment
AKTIV1 | R | 1 | Limit value active (per limit value available)
GRENZWERT1 | F | 20 | Technical value or ID number of a linked variable for a dynamic limit (see VARIABLEx) (if VARIABLEx is 1 and here it is -1, the existing variable linkage is not overwritten)
SCHWWERT1 | F | 16 | Threshold value for limit
HYSTERESE1 | F | 14 | Hysteresis in %
BLINKEN1 | R | 1 | Set blink attribute
BTB1 | R | 1 | Logging in CEL
ALARM1 | R | 1 | Alarm
DRUCKEN1 | R | 1 | Printer output (for CEL or Alarm)
QUITTIER1 | R | 1 | Must be acknowledged
LOESCHE1 | R | 1 | Must be deleted
VARIABLE1 | R | 1 | Dyn. limit value linking the limit is defined by an absolute value (see field GRENZWERTx).
FUNC1 | R | 1 | Function linking
ASK_FUNC1 | R | 1 | With interrogation before execution
FUNC_NR1 | N | 10 | ID number of the linked function (if “-1” is entered here, the existing function is not overwritten during import)
A_GRUPPE1 | N | 10 | Alarm/event group
A_KLASSE1 | N | 10 | Alarm/event class
MIN_MAX1 | C | 3 | Minimum, Maximum
FARBE1 | N | 10 | Color as Windows coding
GRENZTXT1 | C | 66 | Limit value text
A_DELAY1 | N | 10 | Time delay
INVISIBLE1 | R | 1 | Invisible

Expressions in the column "Comment" refer to the expressions used in the dialog boxes for the definition of variables. For more information, see chapter Variable definition.


Offline import

Logix32 -> Creating variables -> Creating variables by importing -> Offline import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The offline import makes it possible to import variables from file LOGIX_PDFEF.txt. Only real variables are imported, no alias.

attention Attention

The file LOGIX_PDEF.txt must be in the same folder as the driver EXE file for the import. The definitions of all predefined types that are necessary for import from L5K files are contained in this.

Importing variables

Right click on the driver and select Import variable from the driver... from the context menu Alternatively, you can also click on the corresponding button in the toolbar to start the import of variables.

The following settings are available.

Parameters

Description

Connection

Select an existing connection. You configure the connections under TCP/IP connection.

Prefix

If you would like to issue the variable to be imported with a prefix, enter the desired prefix.

Import of

Select the import source using the option field:

  • Online Import - import the variables directly from the PLC
  • Offline Import - Here, the variables are imported from the L5K file. To do this, enter the path to the desired L5K file or select it using the file selection dialog. Click on ..., to display the file selection dialog.

Filter

Note: The program list is automatically imported as soon as you activate the checkbox.

Activate the checkbox if you would like to use a filter. You have the possibility to filter according to:

  • Data types
  • Programs
  • Variable groups (all variables, only global variables, only local variables)

Options

Offer only not available variables

Activate this checkbox if only the variables that do not exist in zenon are to be displayed.

Search for variables to be deleted

Activate this checkbox if you would like to have an additional variable selection dialog displayed, in which all variables are displayed that exist for this driver in zenon but not in the PLC. Variables that you select in this dialog are deleted.

Click on Next to import the variables.

All variables to be created are displayed in the following dialog.

Parameters | Description
Name | Name and/or address of the variables in the PLC and/or in zenon.
Data type | Data type of the variable in zenon.
Alias | 1, if the variable is an alias variable, otherwise 0.
Internal | 1, if the variable is an internal variable, otherwise 0. Note for Logix ODVA: Internal variables are created here as SPECIAL MARKERS, because they can only be read by the ODVA driver as unblocked.

Insert the desired variables and click on OK to create them.

If you have activated Search for variables to be deleted, the following dialog is displayed to you.

Parameters | Description
Name or identification | Name or identification of the variable, depending on the setting in the driver configuration for addressing. Contains the address or the name of the variable as it exists in the PLC.
Name | Name of the variable in zenon.


Variable export

Logix32 -> Creating variables -> Creating variables by importing -> Variable export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Variable export to *.csv file

For zenon 5.50, the driver of version Logix32.exe "5.2.0.20" and above and Logix32V.dll "5.2.0.3" and above received an option to export variables of a controller tag in the browser dialog to a *.csv file.

The dialog contains two new elements: the "Show all tags" checkbox and the file button.

Show all tags:

With this option, all items of a controller tag will be displayed, even the ones that have already been included in zenon.

This button opens the "Save as" dialog, which allows you to specify the location for storing the *.csv file. After confirming the "Save as" dialog, the file will be stored - with all items of the controller tag, even the ones that are not displayed.

File structure:

The file starts with a HEADER that contains the time and the driver revision.

Then, the items follow, according to the following structure:

variable name;data type;current value

'DATETIME: 12.07.04 08:53:30

'DRIVER-REVISION:5.2.0.20

Schachteltest_Theo.Ebene0.Ebene1.Ebene2.Variable1;INT;21

Schachteltest_Theo.Ebene0.Ebene1.Ebene2.Variable2;INT;22

Schachteltest_Theo.Ebene0.Ebene1.Ebene2.Variable3;INT;23

Schachteltest_Theo.Ebene0.Ebene1.Ebene2.Variable4;INT;24


Driver variables

Logix32 -> Creating variables -> Driver variables

The driver kit implements a number of driver variables. These are divided into:

  • Information
  • Configuration
  • Statistics and
  • Error messages

The definitions of the variables defined in the driver kit are available in the import file drvvar.dbf (on the CD in the directory: CD_Drive:/Predefined/Variables) and can be imported from there.

Hint: Variable names must be unique in zenon. If driver variables are to be imported from drvvar.dbf again, the variables that were imported beforehand must be renamed.

info Info

Not every driver supports all driver variants.

For example:

  • Variables for modem information are only supported by modem-compatible drivers
  • Driver variables for the polling cycle only for pure polling drivers
  • Connection-related information such as ErrorMSG only for drivers that only edit one connection at a a time

Information

Name from import | Type | Offset | Description
MainVersion | UINT | 0 | Main version number of the driver.
SubVersion | UINT | 1 | Sub version number of the driver.
BuildVersion | UINT | 29 | Build version number of the driver.
RTMajor | UINT | 49 | zenon main version number
RTMinor | UINT | 50 | zenon sub version number
RTSp | UINT | 51 | zenon service pack number
RTBuild | UINT | 52 | zenon build number
LineStateIdle | BOOL | 24.0 | TRUE, if the modem connection is idle
LineStateOffering | BOOL | 24.1 | TRUE, if a call is received
LineStateAccepted | BOOL | 24.2 | The call is accepted
LineStateDialtone | BOOL | 24.3 | Dialtone recognized
LineStateDialing | BOOL | 24.4 | Dialing active
LineStateRingBack | BOOL | 24.5 | While establishing the connection
LineStateBusy | BOOL | 24.6 | Target station is busy
LineStateSpecialInfo | BOOL | 24.7 | Special status information received
LineStateConnected | BOOL | 24.8 | Connection established
LineStateProceeding | BOOL | 24.9 | Dialing completed
LineStateOnHold | BOOL | 24.10 | Connection in hold
LineStateConferenced | BOOL | 24.11 | Connection in conference mode.
LineStateOnHoldPendConf | BOOL | 24.12 | Connection in hold for conference
LineStateOnHoldPendTransfer | BOOL | 24.13 | Connection in hold for transfer
LineStateDisconnected | BOOL | 24.14 | Connection stopped
LineStateUnknow | BOOL | 24.15 | Connection status unknown
ModemStatus | UDINT | 24 | Current modem status
TreiberStop | BOOL | 28 | Driver stopped For driver stop, the variable has the value TRUE and an OFF bit. After the driver has started, the variable has the value FALSE and no OFF bit.
SimulRTState | UDINT | 60 | Informs the status of Runtime for driver simulation.

Configuration

Name from import | Type | Offset | Description
ReconnectInRead | BOOL | 27 | If TRUE, the modem is automatically reconnected for reading
ApplyCom | BOOL | 36 | Apply changes in the settings of the serial interface. Writing to this variable immediately results in the method SrvDrvVarApplyCom being called (which currently has no further function).
ApplyModem | BOOL | 37 | Apply changes in the settings of the modem. Writing this variable immediately calls the method SrvDrvVarApplyModem. This closes the current connection and opens a new one according to the settings PhoneNumberSet and ModemHwAdrSet.
PhoneNumberSet | STRING | 38 | Telephone number, that should be used
ModemHwAdrSet | DINT | 39 | Hardware address for the telephone number
GlobalUpdate | UDINT | 3 | Update time in milliseconds (ms).
BGlobalUpdaten | BOOL | 4 | TRUE, if update time is global
TreiberSimul | BOOL | 5 | TRUE, if driver in sin simulation mode
TreiberProzab | BOOL | 6 | TRUE, if the variables update list should be kept in the memory
ModemActive | BOOL | 7 | TRUE, if the modem is active for the driver
Device | STRING | 8 | Name of the serial interface or name of the modem
ComPort | UINT | 9 | Number of the serial interface.
Baud rate | UDINT | 10 | Baud rate of the serial interface.
Parity | SINT | 11 | Parity of the serial interface
ByteSize | SINT | 14 | Number of bits per character of the serial interface Value = 0 if the driver cannot establish any serial connection.
StopBit | SINT | 13 | Number of stop bits of the serial interface.
Autoconnect | BOOL | 16 | TRUE, if the modem connection should be established automatically for reading/writing
PhoneNumber | STRING | 17 | Current telephone number
ModemHwAdr | DINT | 21 | Hardware address of current telephone number
RxIdleTime | UINT | 18 | Modem is disconnected, if no data transfer occurs for this time in seconds (s)
WriteTimeout | UDINT | 19 | Maximum write duration for a modem connection in milliseconds (ms).
RingCountSet | UDINT | 20 | Number of ringing tones before a call is accepted
ReCallIdleTime | UINT | 53 | Waiting time between calls in seconds (s).
ConnectTimeout | UDINT | 54 | Time in seconds (s) to establish a connection.

Statistics

Name from import | Type | Offset | Description
MaxWriteTime | UDINT | 31 | The longest time in milliseconds (ms) that is required for writing.
MinWriteTime | UDINT | 32 | The shortest time in milliseconds (ms) that is required for writing.
MaxBlkReadTime | UDINT | 40 | Longest time in milliseconds (ms) that is required to read a data block.
MinBlkReadTime | UDINT | 41 | Shortest time in milliseconds (ms) that is required to read a data block.
WriteErrorCount | UDINT | 33 | Number of writing errors
ReadSucceedCount | UDINT | 35 | Number of successful reading attempts
MaxCycleTime | UDINT | 22 | Longest time in milliseconds (ms) required to read all requested data.
MinCycleTime | UDINT | 23 | Shortest time in milliseconds (ms) required to read all requested data.
WriteCount | UDINT | 26 | Number of writing attempts
ReadErrorCount | UDINT | 34 | Number of reading errors
MaxUpdateTimeNormal | UDINT | 56 | Time since the last update of the priority group Normal in milliseconds (ms).
MaxUpdateTimeHigher | UDINT | 57 | Time since the last update of the priority group Higher in milliseconds (ms).
MaxUpdateTimeHigh | UDINT | 58 | Time since the last update of the priority group High in milliseconds (ms).
MaxUpdateTimeHighest | UDINT | 59 | Time since the last update of the priority group Highest in milliseconds (ms).
PokeFinish | BOOL | 55 | Goes to 1 for a query, if all current pokes were executed

Error messages

Name from import | Type | Offset | Description
ErrorTimeDW | UDINT | 2 | Time (in seconds since 1.1.1970), when the last error occurred.
ErrorTimeS | STRING | 2 | Time (in seconds since 1.1.1970), when the last error occurred.
RdErrPrimObj | UDINT | 42 | Number of the PrimObject, when the last reading error occurred.
RdErrStationsName | STRING | 43 | Name of the station, when the last reading error occurred.
RdErrBlockCount | UINT | 44 | Number of blocks to read when the last reading error occurred.
RdErrHwAdresse | UDINT | 45 | Hardware address when the last reading error occurred.
RdErrDatablockNo | UDINT | 46 | Block number when the last reading error occurred.
RdErrMarkerNo | UDINT | 47 | Marker number when the last reading error occurred.
RdErrSize | UDINT | 48 | Block size when the last reading error occurred.
DrvError | SINT | 25 | Error message as number
DrvErrorMsg | STRING | 30 | Error message as text
ErrorFile | STRING | 15 | Name of error log file


Driver-specific functions

Logix32 -> Driver-specific functions

This driver supports the following functions:

Blockwrite:

If you want to set many value at the same time (e.g. for recipes), you can pack the individual variables together and send them in a few telegrams.

Activating blockwrite in the Projekt.ini file:

[LOGIX]

BLOCKWRITE=1


Driver commands

Logix32 -> Driver commands

This chapter describes standard functions that are valid for most zenon drivers. Not all functions described here are available for every driver. For example, a driver that does not, according to the data sheet, support a modem connection also does not have any modem functions.

Driver commands are used to influence drivers using zenon; start and stop for example.
The engineering is implemented with the help of function Driver commands. To do this:

  • create a new function
  • select Variables -> Driver commands
  • The dialog for configuration is opened

Parameters

Description

Drivers

Drop-down list with all drivers which are loaded in the project.

Current state

Fixed entry which has no function in the current version.

Driver commands

Drop-down list for the selection of the command.
  • Start driver (online mode)

Driver is reinitialized and started.
  • Stop driver (offline mode)

Driver is stopped. No new data is accepted.

Note: If the driver is in offline mode, all variables that were created for this driver receive the status switched off (OFF; Bit 20).

  • Driver in simulation mode

Driver is set into simulation mode.
The values of all variables of the driver are simulated by the driver. No values from the connected hardware (e.g. PLC, bus system, ...) are displayed.
  • Driver in hardware mode

Driver is set into hardware mode.
For the variables of the driver the values from the connected hardware (e.g. PLC, bus system, ...) are displayed.
  • Driver-specific command

Enter driver-specific commands. Opens input field in order to enter a command.
  • Activate driver write set value

Write set value to a driver is allowed.
  • Deactivate driver write set value

Write set value to a driver is prohibited.
  • Establish connection with modem

Establish connection (for modem drivers) Opens the input fields for the hardware address and for the telephone number.
  • Disconnect from modem

Terminate connection (for modem drivers)

Show this dialog in the Runtime

The dialog is shown in Runtime so that changes can be made.

Driver commands in the network

If the computer, on which the driver command function is executed, is part of the zenon network, additional actions are carried out. A special network command is sent from the computer to the project server, which then executes the desired action on its driver. In addition, the Server sends the same driver command to the project standby. The standby also carries out the action on its driver.

This makes sure that Server and Standby are synchronized. This only works if the Server and the Standby both have a working and independent connection to the hardware.


Error analysis

Logix32 -> Error analysis

Should there be communication problems, this chapter will assist you in finding out the error.


Error entries

Logix32 -> Error analysis -> Error entries

The driver writes error entries in plain text.

Common error messages

Number | Meaning | Reason
CIP |  |
-1 | EIPERROR | Error in the communication via Ethernet IP of TCP.
-2 | TIMEOUT | Timeout error.
-3 | PROT | Error in the CIP protocol.
0 | OK | Successful communication.
EIP |  |
0 | TIMEOUT | Timeout error.
-1 | ERROR | Protocol error or TCP error.
-2 | BUFFER | Insufficient buffer size.

Error array size

If you specified an array size that was to big, the following entry will be written to the log file.

11.06.04 11:25:17 | Error to Large Array Bytesize:10968 for this zenon Variables the Logix Bytesize:10960 Typesize:10960 GetDataFromTag:Logix32Dump Item:Logix32Dump from IP Adress:192.168.0.212 Failed HW:0 SocketError:0x0 Para1=0 Para2=0

This says that 10968 Bytes were queried, but only 10960 are available on the PLC.


Analysis tool

Logix32 -> Error analysis -> Analysis tool

All zenon modules such as Editor, Runtime, drivers, etc. write messages to a joint log file. To display them correctly and clearly, use the Diagnosis Viewer program that was also installed with zenon. You can find it under Start/All programs/zenon/Tools 7.00 -> Diagviewer.

zenon driver log all errors in the log files. The default folder for the log files is subfolder LOG in directory ProgramData, example: C:\ProgramData\zenon \zenon700\LOG for zenon version 7.00 SP0. Log files are text files with a special structure.

Attention: With the default settings, a driver only logs error information. With the Diagnosis Viewer you can enhance the diagnosis level for most of the drivers to "Debug" and "Deep Debug". With this the driver also logs all other important tasks and events.

In the Diagnosis Viewer you can also:

  • follow currently created entries live
  • customize the logging settings
  • change the folder in which the log files are saved

Hints:

  1. In Windows CE even errors are not logged per default due to performance reasons.
  2. The Diagnosis Viewer displays all entries in UTC (coordinated world time) and not in local time.
  3. The Diagnosis Viewer does not display all columns of a log file per default. To display more columns activate property Add all columns with entry in the context menu of the column header.
  4. If you only use Error logging, the problem description is in column Error text. For other diagnosis level the description is in column General text.
  5. For communication problems many drivers also log error numbers which the PLC assigns to them. They are displayed in Error text and/or Error code and/or Driver error parameter(1 and 2). Hints on the meaning of error codes can be found in the driver documentation and the protocol/PLC description.
  6. At the end of your test set back the diagnosis level from Debug or Deep Debug. At Debug and Deep Debug there are a great deal of data for logging which are saved to the hard drive and which can influence your system performance. They are still logged even after you close the Diagnosis Viewer.

info Info

You can find further information on the Diagnosis Viewer in the Diagnose Viewer chapter.


Check list

Logix32 -> Error analysis -> Check list

Cable disconnected.

Wrong network parameters in the CP or PC.

Wrong String length (too long).

Too slow: scattered data areas; increase update time.

When resolving the name via the identification, make sure that you use a unique identification.

There will be a problem if you configured several connections with the same identification in one driver. (Change DriverKit 5.50 SP6)